##Calcular areas perimetros e comprimentos v3c=name
##Shape_a_calcular=vector
from qgis.core import *
from qgis.utils import *
from PyQt4.QtGui import *
import os
from PyQt4.QtCore import QFile, QFileInfo
from PyQt4.QtCore import QVariant

# Identificar e activar a layer vectorial de poligonos escolhida em Shape_a_calcular
theactivelayer = processing.getObject(Shape_a_calcular)
iface.setActiveLayer(theactivelayer)
# Determinar o codigo EPSG da layer escolhida e avisar caso seja WGS84
layer1= iface.activeLayer()
lyrCRS = layer1.crs().authid()
if lyrCRS=="EPSG:4326":
    QMessageBox.information(None, "Nota", "A layer activa encontra-se no sistema de coordenadas geograficas WGS84(EPSG:4326). Projecte esta layer num sistema de coordenadas planas para poder calcular areas e comprimentos em unidades metricas. A terminar script.")
else:
    # Segue em frente se a layer activa estah em coordenadas planas
    geomTypeString1=QgsWKBTypes.displayString(int(theactivelayer.wkbType()))
    # Verificar se a layer activa eh do tipo Ponto
    if theactivelayer.wkbType()==QGis.WKBPoint:   
        QMessageBox.information(None, "Nota", "Este script actua apenas em layers 2D ou 3D do tipo: Polygon e LineString. A terminar script.")
    else:
        if theactivelayer.wkbType()==QGis.WKBPoint25D:   
            QMessageBox.information(None, "Nota", "Este script actua apenas em layers 2D ou 3D do tipo: Polygon e LineString. A terminar script.")
        else:
            # Verificar se a layer activa eh editavel
            theactivelayer.startEditing()
            if not theactivelayer.isEditable():
                QMessageBox.information(None, "Nota", "A layer escolhida pode estar protegida contra escrita (read-only). A terminar script.")
            else:
                # Verificar qual o tipo geometrico flat-type de vector escolhido e activo agora
                features = theactivelayer.getFeatures()
                geomTypeString2=QgsWKBTypes.displayString(int(QgsWKBTypes.flatType(int(theactivelayer.wkbType()))))
                progress.setPercentage(0)
                if (geomTypeString2=="Polygon"):
                   # Eliminar os campos Area_m2, Area_ha e Perimetro, caso eles existam
                    progress.setPercentage(0)
                    theactivelayer.startEditing()
                    theFields = []
                    for field in theactivelayer.fields():
                        idx = theactivelayer.fieldNameIndex('Area_m2')
                        theFields.append(idx)
                        idx = theactivelayer.fieldNameIndex('Area_ha')
                        theFields.append(idx)
                        idx = theactivelayer.fieldNameIndex('Perimetro')
                        theFields.append(idx)
                    theactivelayer.deleteAttributes(theFields)
                    theactivelayer.updateFields()
                    theactivelayer.commitChanges()
                    progress.setPercentage(25)
                    # Criar novos campos Area_m2, Area_ha e Perimetro e calcular os respectivos valores
                    theactivelayer.startEditing()
                    #   Calcular areas e perimetros
                    theactivelayer.dataProvider().addAttributes([QgsField("Area_m2",  QVariant.Double, "double", 15, 3)])
                    theactivelayer.updateFields()
                    idx=theactivelayer.fieldNameIndex('Area_m2')
                    e=QgsExpression('$area')
                    e.prepare(theactivelayer.pendingFields())
                    for f in theactivelayer.getFeatures():
                        f[idx]=e.evaluate(f)
                        theactivelayer.updateFeature(f)
                    progress.setPercentage(50)
                    theactivelayer.dataProvider().addAttributes([QgsField("Area_ha",  QVariant.Double, "double", 10, 3)])
                    theactivelayer.updateFields()
                    idx=theactivelayer.fieldNameIndex('Area_ha')
                    e=QgsExpression('$area/10000')
                    e.prepare(theactivelayer.pendingFields())
                    for f in theactivelayer.getFeatures():
                        f[idx]=e.evaluate(f)
                        theactivelayer.updateFeature(f)
                    progress.setPercentage(75)
                    theactivelayer.dataProvider().addAttributes([QgsField("Perimetro",  QVariant.Double, "double", 10, 3)])
                    theactivelayer.updateFields()
                    idx=theactivelayer.fieldNameIndex('Perimetro')
                    e=QgsExpression('$perimeter')
                    e.prepare(theactivelayer.pendingFields())
                    for f in theactivelayer.getFeatures():
                        f[idx]=e.evaluate(f)
                        theactivelayer.updateFeature(f)
                    progress.setPercentage(100)
                    theactivelayer.commitChanges()
                elif geomTypeString2=="LineString":
                    bandeira = [1]
                    progress.setPercentage(0)
                    # Eliminar campos Comp_m e Comp_km
                    theactivelayer.startEditing()
                    theFields = []
                    progress.setPercentage(25)
                    for field in theactivelayer.fields():
                        idx = theactivelayer.fieldNameIndex('Comp_m')
                        theFields.append(idx)
                        idx = theactivelayer.fieldNameIndex('Comp_km')
                        theFields.append(idx)                
                    theactivelayer.deleteAttributes(theFields)
                    theactivelayer.updateFields()
                    theactivelayer.commitChanges()
                    progress.setPercentage(50)
                    # Criar novos campos Area_m2, Area_ha e Perimetro e calcular os respectivos valores
                    theactivelayer.startEditing()
                    #   Calcular comprimentos
                    theactivelayer.dataProvider().addAttributes([QgsField("Comp_m",  QVariant.Double, "double", 15, 3)])
                    theactivelayer.updateFields()
                    idx=theactivelayer.fieldNameIndex('Comp_m')
                    e=QgsExpression('$length')
                    e.prepare(theactivelayer.pendingFields())
                    for f in theactivelayer.getFeatures():
                        f[idx]=e.evaluate(f)
                        theactivelayer.updateFeature(f)
                    progress.setPercentage(75)
                    theactivelayer.dataProvider().addAttributes([QgsField("Comp_km",  QVariant.Double, "double", 10, 3)])
                    theactivelayer.updateFields()
                    idx=theactivelayer.fieldNameIndex('Comp_km')
                    e=QgsExpression('$length/1000')
                    e.prepare(theactivelayer.pendingFields())
                    for f in theactivelayer.getFeatures():
                        f[idx]=e.evaluate(f)
                        theactivelayer.updateFeature(f)
                    progress.setPercentage(100)
                    theactivelayer.commitChanges()
                else:
                    if (geomTypeString2=="MultiPolygon"):
                        QMessageBox.information(None, "Nota", "Este script nao actua em layers 2D ou 3D do tipo MultiPolygon. A terminar script.")
                    if (geomTypeString2=="MultiLineString"):
                        QMessageBox.information(None, "Nota", "Este script nao actua em layers 2D ou 3D do tipo MultiLineString. A terminar script.")   
#
